<!--车辆排班   保养弹框-->
<template>
  <el-dialog title="保养用车" :visible.sync="baoyang" width="10%">
    <el-form :model="currentItem"  ref="currentItem" label-width="120px">
        <el-form-item label="车牌号:">
          <span>{{currentItem.item.numberPlate}}</span>
        </el-form-item>
      <el-form-item label="所属公司:">
        <span>{{currentItem.item.subordinateBranchName}}</span>
      </el-form-item>
      <el-form-item label="当前停靠公司:">
        <span>{{currentItem.item.parkCompanyName}}</span>
      </el-form-item>
      <el-form-item label="还车公司:">
        <span>{{currentItem.ii.vehicleBookRecord.retCompanyName}}</span>
      </el-form-item>
      <el-form-item label="保养人:">
        <span>{{currentItem.ii.vehicleBookRecord.bookUserName}}</span>
      </el-form-item>
      <el-form-item label="预定时间:">
        <span>{{currentItem.ii.vehicleBookRecord.bookStartDate}}~{{currentItem.ii.vehicleBookRecord.bookEndDate}}</span>
      </el-form-item>
      <el-form-item label="用途:">
        <span>保养</span>
      </el-form-item>
      <el-form-item label="保养项目:">
        <span>{{upkeepStr}}</span>
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer" v-if="currentItem.ii.vehicleBookRecord.status==2&&bookRecord_btn_unbook&&currentItem.ii.vehicleBookRecord.vehicleDepartureLogVo!=undefined">
      <el-button @click="cancel()">取消用车</el-button>
    </div>
    <div slot="footer" v-if='currentItem.ii.vehicleBookRecord.status==1' class="dialog-footer">
      <el-button type="primary" @click="agree()" v-if="bookRecord_btn_prove">同 意</el-button>
      <el-button @click="notAgree()" v-if="bookRecord_btn_reject">不同意</el-button>
    </div>
  </el-dialog>
</template>
<script>
  import {mapGetters} from 'vuex';
  import ElRow from "element-ui/packages/row/src/row";
  import ElCol from "element-ui/packages/col/src/col";
  import ElFormItem from "../../../../node_modules/element-ui/packages/form/src/form-item.vue";
  import {
    agreeBook,
    cancleBook,
    rejectBook,
    getUpkeepAll
  } from 'api/vehicle/vehicleSchedulManage';
  export default {
    components: {
      ElFormItem,
      ElCol,
      ElRow},
    props: ["currentItem"],
    name: 'vehicleMaintenanceModal',
    data() {
      return {
        baoyang:false,
        upkeepStr:'',
        bookRecord_btn_prove:false,
        bookRecord_btn_reject:false,
        bookRecord_btn_unbook:false,
      }
    },
    created() {
      this.bookRecord_btn_prove = this.elements['bookRecord:btn_prove'];
      this.bookRecord_btn_reject = this.elements['bookRecord:btn_reject'];
      this.bookRecord_btn_unbook = this.elements['bookRecord:btn_unbook'];
      getUpkeepAll().then(response => {
        var arr = this.currentItem.ii.vehicleBookRecord.upkeepIds.split(",");
        var str = '';
        arr.forEach(function(item){
          response.data.forEach(function(itm){
            if(itm.id==item){
              str += itm.name + '、';
              return;
            }
          })
        })
        this.upkeepStr = str.substring(0,str.length-1);
      })
      console.log(this.currentItem);
    },
    computed: {
      ...mapGetters([
        'elements',
      ]),
    },
    watch: {
      baoyang(newValue, oldValue){
        if(!newValue){
          this.$emit("baoyangDialogEvent", false);
        }
      },
    },
    mounted() {
      this.baoyang = true;
    },
    methods: {
      /**
       * 保养-弹框-取消
       * */
      cancel() {
        var obj = {
            vehicleBookRecordId:this.currentItem.ii.vehicleBookRecord.id
        }
        cancleBook(obj).then(response => {
          if(response.code==1){
            this.$emit("zhanlanDialogEvent", true);
            this.$emit("baoyangDialogEvent", true);
          }else{
            this.$notify({
              title: '失败',
              message: response.message,
              type: 'error',
              duration: 2000
            });
          }
        });
      },
      /**
       * 同意
       */
      agree(){
        console.log("同意");
        agreeBook(this.currentItem.ii.vehicleBookRecord.id).then(response => {this.$emit("zhanlanDialogEvent", true);});
      },
      /**
       * 不同意
       */
      notAgree(){
        console.log("不同意");
        var obj = {
            vehicleBookRecordId:this.currentItem.ii.vehicleBookRecord.id
        }
        rejectBook(obj).then(response => {
          if(response.code==1){
            this.$emit("baoyangDialogEvent", true);
          }else{
            this.$notify({
              title: '失败',
              message: response.message,
              type: 'error',
              duration: 2000
            });
          }
        });
      },
    }
  }
</script>

